class ItemsToCatch
{
  SingleItem[] myitems = new SingleItem[5];
  
  ItemsToCatch(int min, int max, PImage gi)
  {
    for (int s=0; s<myitems.length; s++) {
      myitems[s] = new SingleItem(min,max,gi);
    }
  }
  
  ItemsToCatch(int min, int max, PImage gi, PImage bi)
  {
    for (int s=0; s<myitems.length-1; s++) {
      myitems[s] = new SingleItem(min,max,gi,1);
    }
    myitems[myitems.length-1] = new SingleItem(min,max,bi,-2);
  }
  
  void move()
  {
    for (int s=0; s<myitems.length; s++) {
      myitems[s].move();
    }
  }
  
  void drawOnScreen()
  {
    for (int s=0; s<myitems.length; s++) {
      myitems[s].drawOnScreen();
    }
  }
  
  void confirmCatch(Catcher c)
  {
    for (int s=0; s<myitems.length; s++) {
      myitems[s].confirmCatch(c);
    }
  }

}

class SingleItem
{
  int xloc = 0;
  int xMinLoc = 0;
  int xMaxLoc = 0;
  int yloc = 0;
  int size = 25;
  int speedY = 10;
  PImage itemImage;
  int pointValue = 1;
  
  SingleItem(int min, int max, PImage ii) {
    xMinLoc = min;
    xMaxLoc = max;
    resetPosition(xMinLoc,xMaxLoc);
    itemImage = ii;
  }
  
  SingleItem(int min, int max, PImage ii, int pv) {
    xMinLoc = min;
    xMaxLoc = max;
    resetPosition(xMinLoc,xMaxLoc);
    itemImage = ii;
    pointValue = pv;
  }
  
  void move()
  {
    
    yloc += speedY;
    if(yloc >= 600)
    {
      resetPosition(xMinLoc,xMaxLoc);
    }
  }
  
  void resetPosition(int min, int maxm)
  {
    xloc = (int)random(xMaxLoc-xMinLoc)+xMinLoc;
    yloc = (int)random(600)*-1;
  }
  
  void drawOnScreen()
  {
    imageMode(CENTER);
    image(itemImage,xloc,yloc);
  }
  
  boolean confirmCatch(Catcher c)
  {
    if (c.getX() >= xloc - size && c.getX() <= xloc + size &&
        c.getY() >= yloc - size && c.getY() <= yloc + size)
    {
      resetPosition(xMinLoc,xMaxLoc);
      c.addToScore(pointValue);
      if (pointValue > 0) {
        c.goodCatch = true;
      } else {
        c.badCatch = true;
      }
      return true;
    } else {
      return false;
    }
  }
  
  int getX()
  {
    return xloc;
  }
  int getY()
  {
    return yloc;
  }
}