// This version was remixed by

// Background - GIVE IT A NAME
PImage p1BackgroundImage;
PImage p2BackgroundImage;

// Stuff to Catch - GIVE IT A NAME
ItemsToCatch stuffToCatch1;
ItemsToCatch stuffToCatch2;
PImage p1GoodStuffImage;
PImage p1BadStuffImage;
PImage p2GoodStuffImage;
PImage p2BadStuffImage;

// Catcher - GIVE IT A NAME
Catcher player1;
Catcher player2;
PImage p1CatcherImage;
PImage p2CatcherImage;

// Scoreboard - GIVE IT A NAME
Scoreboard myScoreboard;

// Sound FX and Music - GIVE IT A NAME
//import ddf.minim.*;
//Minim minim;
//AudioSample goodCatchSound;
//AudioSample badCatchSound;
//AudioSample soundtrack;

void setup()
{

  // Overall Window Setup
  frameRate(45);
  rectMode(CENTER);
  imageMode(CENTER);
  size(800, 600);
  background(255);

  // Background - LOAD INTO MEMORY
  p1BackgroundImage = loadImage("T3Background.png");
  p2BackgroundImage = loadImage("T2Background.png");

  // Stuff to Catch - LOAD INTO MEMORY
  p1GoodStuffImage = loadImage("T3Cat1.png");
  p1BadStuffImage = loadImage("T3Asteroid2.png");
  p2GoodStuffImage = loadImage("T2Bubble.png");
  p2BadStuffImage = loadImage("T1Fish.png");
  stuffToCatch1 = new ItemsToCatch(0,400,p1GoodStuffImage,p1BadStuffImage);
  stuffToCatch2 = new ItemsToCatch(400,800,p2GoodStuffImage,p2BadStuffImage);

  // Catcher - LOAD INTO MEMORY
  p1CatcherImage = loadImage("T3Rocket.png");
  p2CatcherImage = loadImage("T2Fish2.png");
  player1 = new Catcher(0,400,p1CatcherImage);
  player2 = new Catcher(400,800,p2CatcherImage);

  // Scoreboard - LOAD INTO MEMORY
  myScoreboard = new Scoreboard();

  // Sound FX and Music - LOAD INTO MEMORY
  //minim = new Minim(this);
  //goodCatchSound = minim.loadSample("blank.aif");
  //badCatchSound = minim.loadSample("blank.aif");
  //soundtrack = minim.loadSample("blank.aif");
  // trigger the soundtrack HERE

}


void draw()
{
  // Background - DRAW IT
  rectMode(CENTER);
  background(255);
  image(p1BackgroundImage,200,300,400,600);
  image(p2BackgroundImage,600,300,400,600);
  fill(255);
  stroke(255);
  line(400,0,400,800);

  // Scoreboard - DRAW IT
  myScoreboard.drawOnScreen(player1,player2);

  // CONDITIONAL: Are we still playing?
  if (myScoreboard.keepPlaying())
  { // IF YES - run the section

    // Stuff to Catch - MOVE IT
    stuffToCatch1.move();
    stuffToCatch2.move();

    // Catcher - MOVE IT
    player1.move();
    player2.move();

    // Check to see if you caught something
    stuffToCatch1.confirmCatch(player1);
    stuffToCatch2.confirmCatch(player2);

  } // IF NOT - skip the section

  // CONDITIONAL: Did player 1 make a good catch?

  // CONDITIONAL: Did player 1 make a bad catch?
  if (player1.badCatch())
  {
    //badCatchSound.trigger();
  }

  // CONDITIONAL: Did player 2 make a good catch?

  // CONDITIONAL: Did player 2 make a bad catch?
  if (player2.badCatch())
  {
    //badCatchSound.trigger();
  }

  // Stuff to Catch - DRAW IT
  stuffToCatch1.drawOnScreen();
  stuffToCatch2.drawOnScreen();

  // Catcher - DRAW IT
  player1.drawOnScreen();
  player2.drawOnScreen();

}

// Pushing Keys Down
void keyPressed()
{
  if (key == CODED)
  {
    if (keyCode == RIGHT)
    {
      player2.changeSpeed(15);
    }
    if (keyCode == LEFT)
    {
      player2.changeSpeed(-15);
    }
    if (keyCode == UP)
    {
      player1.changeSpeed(15);
    }
    if (keyCode == DOWN)
    {
      player1.changeSpeed(-15);
    }
  } else {
    if (key == 'a')
   {
     player1.changeSpeed(-15);
   }
   if (key == 's')
   {
     player1.changeSpeed(15);
   }
 }
}

// Letting Keys Up
void keyReleased()
{
  if (key == CODED)
 {
   if (keyCode == RIGHT)
   {
     player2.changeSpeed(0);
   }
   if (keyCode == LEFT)
   {
     player2.changeSpeed(0);
   }
   if (keyCode == UP)
   {
     player1.changeSpeed(0);
   }
   if (keyCode == DOWN)
   {
     player1.changeSpeed(0);
   }
 } else {
   if (key == 'a')
   {
     player1.changeSpeed(0);
   }
   if (key == 's')
   {
     player1.changeSpeed(0);
   }
 }
}
